<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
<!--      <template slot="menuLeft">-->
<!--        <el-button type="danger"-->
<!--                   size="small"-->
<!--                   icon="el-icon-delete"-->
<!--                   plain-->
<!--                   v-if="permission.aftersales_delete"-->
<!--                   @click="handleDelete">删 除-->
<!--        </el-button>-->
<!--      </template>-->

        <template slot-scope="scope" slot="menu">
            <el-button
                    v-if="scope.row.refundState == 0 && scope.row.status == 3"
                    type="text"
                    size="small"
                    @click="openRefundApplyBox(scope.row)"
            >退款审核
            </el-button>
        </template>

        <!--  添加商品插槽    -->
        <template slot="goodsForm">
            <avue-crud :option="goodsTableOption"
                       :data="tableData"
                       ref="crudGoods">
                <template slot="grouponPrice" slot-scope="scope" >
                    <avue-input-number precision="2" v-model="scope.row.grouponPrice"></avue-input-number>
                </template>
            </avue-crud>
        </template>
    </avue-crud>

      <el-dialog title="退款审核" @close="refreshChange"
                 append-to-body
                 :visible.sync="auditBox"
                 :before-close="handleClose"
                 width="600px"
                 heigh="40%">
          <el-form :model="auditForm" label-width="80px">
              <el-form-item label="审核意见:">
                  <el-select v-model="auditForm.auditStatus" placeholder="请选择">
                      <el-option
                              v-for="item in auditList"
                              :key="item.value"
                              :label="item.name"
                              :value="item.value">
                      </el-option>
                  </el-select>
              </el-form-item>
              <el-form-item label="驳回描述:" v-if="auditForm.auditStatus == 2">
                  <el-input type="textarea" v-model="auditForm.remark" :autosize="{ minRows: 3, maxRows: 5}"></el-input>
              </el-form-item>
          </el-form>
          <div slot="footer" class="dialog-footer">
              <el-button @click="handleClose">取 消</el-button>
              <el-button type="primary" @click="refundApply()">确 定</el-button>
          </div>
      </el-dialog>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove, refund, refundApply} from "@/api/finance/aftersales";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
          auditList: [
              {name: '通过', value: 1}, {name: '驳回', value: 2}
          ],
          auditForm: {
              auditStatus: '',
              afterSalesId: '',
              remark: ''
          },
          auditBox: false,
          tableData: [],
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          addBtn: false,
          editBtn: false,
          delBtn: false,
          selection: false,
          dialogClickModal: false,
          column: [
            {
              label: "售后编号",
              prop: "afterSalesNo",
              rules: [{
                required: true,
                message: "请输入售后编号",
                trigger: "blur"
              }]
            },
            {
              label: "售后类型",
              prop: "type",
              type: "select",
              search: true,
              dicUrl: "/api/blade-system/dict-biz/getEnumDict?enumName=AfterSalesTypeEnum",
              props: {
                label: "name",
                value: "value"
              },
              dataType: "number",
            },
            {
              label: "售后原因",
              prop: "reason",
              rules: [{
                required: true,
                message: "请输入售后原因",
                trigger: "blur"
              }]
            },
            {
              label: "售后状态",
              prop: "status",
              type: "select",
              search: true,
              dicUrl: "/api/blade-system/dict-biz/getEnumDict?enumName=AfterSalesStatusEnum",
              props: {
                label: "name",
                value: "value"
              },
              dataType: "number",
            },
            {
              label: "退款状态",
              prop: "refundState",
              type: "select",
              search: true,
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=refund_status",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
            },
              {
                  label: "订单编号",
                  prop: "orderNo",
                  hide: true
              },
              {
                  label: "退款商品",
                  prop: "goods",
                  span: 24,
                  fromslot: true,
                  hide: true
              },
          ]
        },
        data: [],
          goodsTableOption : {
              menuWidth: 90,
              refreshBtn: false,
              columnBtn: false,
              addBtn: false,
              viewBtn: false,
              editBtn: false,
              delBtn: false,
              sortable: true,
              menu: false,
              column: [
                  {
                      label: '商品图片',
                      prop: 'goodsImage',
                      type: 'img',
                  },
                  {
                      label: '商品名称',
                      prop: 'goodsName',
                  },
                  {
                      label: '数量',
                      prop: 'goodsNum',
                  },
                  {
                      label: '价格',
                      prop: 'goodsPrice',
                  }
              ]
          }
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.aftersales_add, false),
          viewBtn: this.vaildData(this.permission.aftersales_view, false),
          delBtn: this.vaildData(this.permission.aftersales_delete, false),
          editBtn: this.vaildData(this.permission.aftersales_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
            this.tableData = res.data.data.goodsList;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      },
        refund(row) {
            this.$confirm("确定对该订单退款？", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning"
            }).then(() => {
                const loading = this.$loading({
                    lock: true,
                    text: '退款中...',
                    spinner: 'el-icon-loading',
                    background: 'rgba(0, 0, 0, 0.7)'
                });
                refund(row.orderId, row.id).then(res => {
                    loading.close();
                    this.$message({
                        type: "success",
                        message: "退款成功!"
                    });
                    this.refreshChange();
                }).catch(() => {
                    loading.close();
                });
            });
        },
        openRefundApplyBox(row) {
            this.auditBox = true;
            this.auditForm.afterSalesId = row.id;
        },
        refundApply() {
          if (this.auditForm.auditStatus == 2 && this.auditForm.remark.length < 1) {
              this.$message({
                  type: "error",
                  message: "请输入驳回描述!"
              });
              return;
          }
            const loading = this.$loading({
                lock: true,
                text: '处理中...',
                spinner: 'el-icon-loading',
                background: 'rgba(0, 0, 0, 0.7)'
            });
            refundApply(this.auditForm).then(() => {
                loading.close();
                this.auditBox = false;
                this.onLoad(this.page, this.query);
                this.$message({
                    type: "success",
                    message: "操作成功!"
                });
            }, error => {
                loading.close();
                console.log(error);
            });
        },
        handleClose() {
            this.auditBox = false;
            this.auditForm = {
                auditStatus: '',
                afterSalesId: '',
                remark: ''
            };
        },
    }
  };
</script>

<style>
</style>
